<?php

declare(strict_types=1);

namespace App\Service\DrinkType;

use App\Entity\DrinkType;
use App\Service\Config\LowStockMultiplier;

final readonly class FilterLowStockDrinks
{
    public function __construct(private LowStockMultiplier $lowStockMultiplier) {}

    /** @param DrinkType[] $drinkTypes */
    public function __invoke(array $drinkTypes): array
    {
        return array_filter(
            $drinkTypes,
            fn(DrinkType $drinkType): bool =>
                $drinkType->getCurrentStock() < ($drinkType->getWantedStock() * $this->lowStockMultiplier->getValue())
        );
    }

}
